/* Wiz functions for toying with mortals.  MUHAHAHAHA!!! */

#include "conf.h"
#include "sysdep.h"

#include "structs.h"
#include "utils.h"

#include "comm.h"
#include "db.h"
#include "handler.h"
#include "interpreter.h"


/* extern vars */
int top_of_p_table;
struct player_index_element *player_table;

/* extern functions */
void do_start(struct char_data *ch);
int level_exp(int chclass, int level);
room_rnum find_target_room(struct char_data *ch, char *rawroomstr);


/* local functions */
int set_contact(struct char_data *ch, char *name);
void stop_snooping(struct char_data *ch);
void snoop_check(struct char_data *ch);

ACMD(do_advance);
ACMD(do_chown);
ACMD(do_force);
ACMD(do_players);
ACMD(do_restore);
ACMD(do_send);
ACMD(do_snoop);
ACMD(do_teleport);
ACMD(do_trans);
ACMD(do_warning);
ACMD(do_wizupdate);


ACMD(do_send)
{
	char arg[MAX_INPUT_LENGTH], buf[MAX_INPUT_LENGTH];
	struct char_data *vict;

	half_chop(argument, arg, buf);

	if (!*arg) {
		send_to_char(ch, "Send what to who?\r\n");
		return;
	}
	if (!(vict = get_char_vis(ch, arg, NULL, FIND_CHAR_WORLD))) {
		send_to_char(ch, "%s", NOPERSON);
		return;
	}
	send_to_char(vict, "%s\r\n", buf);

	if (!IS_NPC(vict) && GET_LEVEL(vict) < LVL_IMMORT) {
		if (GET_CONTACT(vict) != NULL) {
			if (strcmp(GET_CONTACT(vict), GET_NAME(ch)))
				set_contact(vict, GET_NAME(ch));
		} else
			set_contact(vict, GET_NAME(ch));
	}

	if (PRF_FLAGGED(ch, PRF_NOREPEAT))
		send_to_char(ch, "Sent.\r\n");
	else
		send_to_char(ch, "You send '%s' to %s.\r\n", buf, GET_NAME(vict));
}



ACMD(do_trans)
{
	char buf[MAX_INPUT_LENGTH];
	struct descriptor_data *i;
	struct char_data *victim;

	one_argument(argument, buf);
	if (!*buf)
		send_to_char(ch, "Whom do you wish to transfer?\r\n");
	else if (str_cmp("all", buf)) {
		if (!(victim = get_char_vis(ch, buf, NULL, FIND_CHAR_WORLD)))
			send_to_char(ch, "%s", NOPERSON);
		else if (victim == ch)
			send_to_char(ch, "That doesn't make much sense, does it?\r\n");
		else {
			if ((GET_LEVEL(ch) < GET_LEVEL(victim)) && !IS_NPC(victim)) {
				send_to_char(ch, "Go transfer someone your own size.\r\n");
				return;
			}
			act("$n disappears in a mushroom cloud.", FALSE, victim, 0, 0, TO_ROOM);
			char_from_room(victim);
			char_to_room(victim, IN_ROOM(ch));
			act("$n arrives from a puff of smoke.", FALSE, victim, 0, 0, TO_ROOM);
			act("$n has transferred you!", FALSE, ch, 0, victim, TO_VICT);
			look_at_room(victim, 0);
		}
	} else {			/* Trans All */
		if (GET_LEVEL(ch) < LVL_GRGOD) {
			send_to_char(ch, "I think not.\r\n");
			return;
		}

		for (i = descriptor_list; i; i = i->next)
			if (STATE(i) == CON_PLAYING && i->character && i->character != ch) {
				victim = i->character;
				if (GET_LEVEL(victim) >= GET_LEVEL(ch))
					continue;
				act("$n disappears in a mushroom cloud.", FALSE, victim, 0, 0, TO_ROOM);
				char_from_room(victim);
				char_to_room(victim, IN_ROOM(ch));
				act("$n arrives from a puff of smoke.", FALSE, victim, 0, 0, TO_ROOM);
				act("$n has transferred you!", FALSE, ch, 0, victim, TO_VICT);
				look_at_room(victim, 0);
			}
		send_to_char(ch, "%s", OK);
	}
}



ACMD(do_teleport)
{
	char buf[MAX_INPUT_LENGTH], buf2[MAX_INPUT_LENGTH];
	struct char_data *victim;
	room_rnum target;

	two_arguments(argument, buf, buf2);

	if (!*buf)
		send_to_char(ch, "Whom do you wish to teleport?\r\n");
	else if (!(victim = get_char_vis(ch, buf, NULL, FIND_CHAR_WORLD)))
		send_to_char(ch, "%s", NOPERSON);
	else if (victim == ch)
		send_to_char(ch, "Use 'goto' to teleport yourself.\r\n");
	else if (GET_LEVEL(victim) >= GET_LEVEL(ch))
		send_to_char(ch, "Maybe you shouldn't do that.\r\n");
	else if (!*buf2)
		send_to_char(ch, "Where do you wish to send this person?\r\n");
	else if ((target = find_target_room(ch, buf2)) != NOWHERE) {
		send_to_char(ch, "%s", OK);
		act("$n disappears in a puff of smoke.", FALSE, victim, 0, 0, TO_ROOM);
		char_from_room(victim);
		char_to_room(victim, target);
		act("$n arrives from a puff of smoke.", FALSE, victim, 0, 0, TO_ROOM);
		act("$n has teleported you!", FALSE, ch, 0, (char *) victim, TO_VICT);
		look_at_room(victim, 0);
	}
}


void snoop_check(struct char_data *ch)
{
	/*  This short routine is to ensure that characters that happen
	 *  to be snooping (or snooped) and get advanced/demoted will
	 *  not be snooping/snooped someone of a higher/lower level (and
	 *  thus, not entitled to be snooping.
	 */
	if (!ch || !ch->desc)
		return;
	if (ch->desc->snooping &&
		 (GET_LEVEL(ch->desc->snooping->character) >= GET_LEVEL(ch))) {
		ch->desc->snooping->snoop_by = NULL;
		ch->desc->snooping = NULL;
	}

	if (ch->desc->snoop_by &&
		 (GET_LEVEL(ch) >= GET_LEVEL(ch->desc->snoop_by->character))) {
		ch->desc->snoop_by->snooping = NULL;
		ch->desc->snoop_by = NULL;
	}
}

void stop_snooping(struct char_data *ch)
{
	if (!ch->desc->snooping)
		send_to_char(ch, "You aren't snooping anyone.\r\n");
	else {
		send_to_char(ch, "You stop snooping.\r\n");
		ch->desc->snooping->snoop_by = NULL;
		ch->desc->snooping = NULL;
	}
}


ACMD(do_snoop)
{
	char arg[MAX_INPUT_LENGTH];
	struct char_data *victim, *tch;

	if (!ch->desc)
		return;

	one_argument(argument, arg);

	if (!*arg)
		stop_snooping(ch);
	else if (!(victim = get_char_vis(ch, arg, NULL, FIND_CHAR_WORLD)))
		send_to_char(ch, "No such person around.\r\n");
	else if (!victim->desc)
		send_to_char(ch, "There's no link.. nothing to snoop.\r\n");
	else if (victim == ch)
		stop_snooping(ch);
	else if (victim->desc->snoop_by)
		send_to_char(ch, "Busy already. \r\n");
	else if (victim->desc->snooping == ch->desc)
		send_to_char(ch, "Don't be stupid.\r\n");
	else {
		if (victim->desc->original)
			tch = victim->desc->original;
		else
			tch = victim;

		if (GET_LEVEL(tch) >= GET_LEVEL(ch)) {
			send_to_char(ch, "You can't.\r\n");
			return;
		}
		send_to_char(ch, "%s", OK);

		if (ch->desc->snooping)
			ch->desc->snooping->snoop_by = NULL;

		ch->desc->snooping = victim->desc;
		victim->desc->snoop_by = ch->desc;
	}
}



ACMD(do_advance)
{
	struct char_data *victim;
	char name[MAX_INPUT_LENGTH], level[MAX_INPUT_LENGTH];
	int newlevel, oldlevel;

	two_arguments(argument, name, level);

	if (*name) {
		if (!(victim = get_char_vis(ch, name, NULL, FIND_CHAR_WORLD))) {
			send_to_char(ch, "That player is not here.\r\n");
			return;
		}
	} else {
		send_to_char(ch, "Advance who?\r\n");
		return;
	}

	if (GET_LEVEL(ch) <= GET_LEVEL(victim)) {
		send_to_char(ch, "Maybe that's not such a great idea.\r\n");
		return;
	}
	if (IS_NPC(victim)) {
		send_to_char(ch, "NO!  Not on NPC's.\r\n");
		return;
	}
	if (!*level || (newlevel = atoi(level)) <= 0) {
		send_to_char(ch, "That's not a level!\r\n");
		return;
	}
	if (newlevel > LVL_IMPL) {
		send_to_char(ch, "%d is the highest possible level.\r\n", LVL_IMPL);
		return;
	}
	if (newlevel > GET_LEVEL(ch)) {
		send_to_char(ch, "Yeah, right.\r\n");
		return;
	}
	if (newlevel == GET_LEVEL(victim)) {
		send_to_char(ch, "They are already at that level.\r\n");
		return;
	}
	oldlevel = GET_LEVEL(victim);
	if (newlevel < GET_LEVEL(victim)) {
		do_start(victim);
		GET_LEVEL(victim) = newlevel;
		send_to_char(victim, "You are momentarily enveloped by darkness!\r\nYou feel somewhat diminished.\r\n");
	} else {
		act("$n makes some strange gestures.\r\n"
			 "A strange feeling comes upon you,\r\n"
			 "Like a giant hand, light comes down\r\n"
			 "from above, grabbing your body, that\r\n"
			 "begins to pulse with colored lights\r\n"
			 "from inside.\r\n\r\n"
			 "Your head seems to be filled with demons\r\n"
			 "from another plane as your body dissolves\r\n"
			 "to the elements of time and space itself.\r\n"
			 "Suddenly a silent explosion of light\r\n"
			 "snaps you back to reality.\r\n\r\n"
			 "You feel slightly different.", FALSE, ch, 0, victim, TO_VICT);
	}

	send_to_char(ch, "%s", OK);

	if (newlevel < oldlevel)
		log("(GC) %s demoted %s from level %d to %d.",
			 GET_NAME(ch), GET_NAME(victim), oldlevel, newlevel);
	else
		log("(GC) %s has advanced %s to level %d (from %d)",
			 GET_NAME(ch), GET_NAME(victim), newlevel, oldlevel);

	if (oldlevel >= LVL_IMMORT && newlevel < LVL_IMMORT) {
		/* If they are no longer an immortal, let's remove some of the
		 * nice immortal only flags, shall we?
		 */
		PRF_FLAGS(victim).PRF_LOG1 = 0;
		PRF_FLAGS(victim).PRF_LOG2 = 0;
		PRF_FLAGS(victim).PRF_NOHASSLE = 0;
		PRF_FLAGS(victim).PRF_HOLYLIGHT = 0;
	}

	gain_exp_regardless(victim,
							  level_exp(GET_CLASS(victim), newlevel) - GET_EXP(victim));
	save_char(victim);
	do_wizupdate(ch, 0, 0, 0);
}



ACMD(do_restore)
{
	char buf[MAX_INPUT_LENGTH];
	struct char_data *vict;
	int i;

	one_argument(argument, buf);
	if (!*buf)
		send_to_char(ch, "Whom do you wish to restore?\r\n");
	else if (!(vict = get_char_vis(ch, buf, NULL, FIND_CHAR_WORLD)))
		send_to_char(ch, "%s", NOPERSON);
	else if (!IS_NPC(vict) && ch != vict && GET_LEVEL(vict) >= GET_LEVEL(ch))
		send_to_char(ch, "They don't need your help.\r\n");
	else {
		GET_HIT(vict) = GET_MAX_HIT(vict);
		GET_MANA(vict) = GET_MAX_MANA(vict);
		GET_MOVE(vict) = GET_MAX_MOVE(vict);

		if (!IS_NPC(vict) && GET_LEVEL(ch) >= LVL_GRGOD) {
			if (GET_LEVEL(vict) >= LVL_IMMORT)
				for (i = 1; i <= MAX_SKILLS; i++)
					SET_SKILL(vict, i, 100);

			if (GET_LEVEL(vict) >= LVL_GRGOD) {
				vict->real_abils.str_add = 100;
				vict->real_abils.intel = 25;
				vict->real_abils.wis = 25;
				vict->real_abils.dex = 25;
				vict->real_abils.str = 25;
				vict->real_abils.con = 25;
				vict->real_abils.cha = 25;
			}
		}
		update_pos(vict);
		affect_total(vict);
		send_to_char(ch, "%s", OK);
		act("You have been fully healed by $N!", FALSE, vict, 0, ch, TO_CHAR);
	}
}


ACMD(do_force)
{
	struct descriptor_data *i, *next_desc;
	struct char_data *vict, *next_force;
	char arg[MAX_INPUT_LENGTH], to_force[MAX_INPUT_LENGTH], buf1[MAX_INPUT_LENGTH + 32];

	half_chop(argument, arg, to_force);

	snprintf(buf1, sizeof(buf1), "$n has forced you to '%s'.", to_force);

	if (!*arg || !*to_force)
		send_to_char(ch, "Whom do you wish to force do what?\r\n");
	else if ((GET_LEVEL(ch) < LVL_GRGOD) || (str_cmp("all", arg) && str_cmp("room", arg))) {
		if (!(vict = get_char_vis(ch, arg, NULL, FIND_CHAR_WORLD)))
			send_to_char(ch, "%s", NOPERSON);
		else if (!IS_NPC(vict) && GET_LEVEL(ch) <= GET_LEVEL(vict))
			send_to_char(ch, "No, no, no!\r\n");
		else {
			send_to_char(ch, "%s", OK);
			act(buf1, TRUE, ch, NULL, vict, TO_VICT);
			mudlog(NRM, MAX(LVL_GOD, GET_INVIS_LEV(ch)), TRUE, "(GC) %s forced %s to %s", GET_NAME(ch), GET_NAME(vict), to_force);
			command_interpreter(vict, to_force);
		}
	} else if (!str_cmp("room", arg)) {
		send_to_char(ch, "%s", OK);
		mudlog(NRM, MAX(LVL_GOD, GET_INVIS_LEV(ch)), TRUE, "(GC) %s forced room %d to %s",
				 GET_NAME(ch), GET_ROOM_VNUM(IN_ROOM(ch)), to_force);

		for (vict = world[IN_ROOM(ch)].people; vict; vict = next_force) {
			next_force = vict->next_in_room;
			if (!IS_NPC(vict) && GET_LEVEL(vict) >= GET_LEVEL(ch))
				continue;
			act(buf1, TRUE, ch, NULL, vict, TO_VICT);
			command_interpreter(vict, to_force);
		}
	} else { /* force all */
		send_to_char(ch, "%s", OK);
		mudlog(NRM, MAX(LVL_GOD, GET_INVIS_LEV(ch)), TRUE, "(GC) %s forced all to %s", GET_NAME(ch), to_force);

		for (i = descriptor_list; i; i = next_desc) {
			next_desc = i->next;

			if (STATE(i) != CON_PLAYING || !(vict = i->character) || (!IS_NPC(vict) && GET_LEVEL(vict) >= GET_LEVEL(ch)))
				continue;
			act(buf1, TRUE, ch, NULL, vict, TO_VICT);
			command_interpreter(vict, to_force);
		}
	}
}



int set_contact(struct char_data *ch, char *name)
{
	if (!strcmp(name, "off")) {
		free(GET_CONTACT(ch));
		return (TRUE);
	}

	if (get_id_by_name(name) < 0)
		return (FALSE);

	if (GET_CONTACT(ch) != NULL)
		free(GET_CONTACT(ch));

	GET_CONTACT(ch) = strdup(name);
	return (TRUE);
}


ACMD(do_warning)
{
	struct char_data *vict = NULL;
	char arg[MAX_STRING_LENGTH], buf[MAX_STRING_LENGTH];
	int all = FALSE;

	half_chop(argument, arg, buf);

	if (!*arg) {
		send_to_char(ch, "Send a warning to who?\r\n");
		return;
	}

	if (!stricmp(arg, "all"))
		all = TRUE;

	else if (!(vict = get_char_vis(ch, arg, NULL, FIND_CHAR_WORLD))) {
		send_to_char(ch, NOPERSON);
		return;
	}

	if (!all && IS_NPC(vict)) {
		send_to_char(ch, NOPERSON);
		return;
	}

	if (!all && GET_LEVEL(ch) < GET_LEVEL(vict)) {
		send_to_char(ch, "You should not warn people who are holier than "
						 "yourself.\r\n");
		return;
	}

	if (!all && ch == vict) {
		send_to_char(ch, "Warning yourself, eh?.\r\n");
		return;
	}

	if (!*buf) {
		send_to_char(ch, "You must enter a warning message.\r\n");
		return;
	}

	if (!all)
		send_to_char(vict, "[WARNING] : %s\r\n", buf);
	else 
		send_to_all("[WARNING] : %s\r\n", buf);
	
	if (!all) /* If you sent to all, you're already seeing it! */
	{
		if (PRF_FLAGGED(ch, PRF_NOREPEAT))
			send_to_char(ch, "Sent.\r\n");
		else 
			send_to_char(ch, "You send '%s' to %s.\r\n", buf, GET_NAME(vict));
	}
}


ACMD(do_players)
{
	int i, count = 0, len = 0, nlen = 0;
	char buf[MAX_STRING_LENGTH];
	*buf = 0;

	for (i = 0; i <= top_of_p_table; i++) {
		nlen = snprintf(buf + len, sizeof(buf) - len, 
							 " %-20.20s", (player_table + i)->name);
		count++;

		if (len + nlen >= sizeof(buf) || nlen < 0) 
			break;
		len += nlen;
		
		if (count == 3) {
			count = 0;
			strcat(buf, "\r\n");
		}
	}
	strcat(buf, "\r\n");

	page_string(ch->desc, buf, TRUE);
}


/* Change Ownership of item from player to IMM
   Idea from Highlands II (hlii.highlands.org 9001)

   Additional code by:
   Christian Duvall - Getting Equipped EQ From Char
   Patrick Dughi    - Schooling me in act()
   AFCervo          - Moral support

   Thanks to everyone that helped make this command! */
ACMD(do_chown)
{
	struct char_data *victim;
	struct obj_data *obj;
	char buf2[MAX_INPUT_LENGTH], buf3[MAX_INPUT_LENGTH];
	int i, k = 0;
	const char *usage = "USAGE: chown <object> <character>.\r\n";

	two_arguments(argument, buf2, buf3);

	if (!*buf2)
		send_to_char(ch, usage);
	else if (!(victim = get_char_vis(ch, buf3, NULL, FIND_CHAR_WORLD)))
		send_to_char(ch, "No one by that name here.\r\n");
	else if (victim == ch)
		send_to_char(ch, "Are you sure you're feeling ok?\r\n");
	else if (GET_LEVEL(victim) >= GET_LEVEL(ch))
		send_to_char(ch, "That's really not such a good idea.\r\n");
	else if (!*buf3)
		send_to_char(ch, usage);
	else {
		for (i = 0; i < NUM_WEARS; i++) {
			if (GET_EQ(victim, i) &&
				 CAN_SEE_OBJ(ch, GET_EQ(victim, i)) &&
				 isname(buf2, GET_EQ(victim, i)->name)) {
				obj_to_char(unequip_char(victim, i), victim);
				k = 1;
			}
		}

		if (!(obj = get_obj_in_list_vis(victim, buf2, NULL, victim->carrying))) {
			if (!k && !(obj = get_obj_in_list_vis(victim, buf2, NULL, victim->carrying))) {
				send_to_char(ch, "%s does not appear to have the %s.\r\n", 
								 GET_NAME(victim), buf2);
				return;
			}
		}

		act("$n makes a magical gesture and $p flies from $N to $m.",
			 FALSE, ch, obj, victim, TO_NOTVICT);
		act("$n makes a magical gesture and $p flies away from you to $m.",
			 FALSE, ch, obj, victim, TO_VICT);
		act("You make a magical gesture and $p flies away from $N to you.",
			 FALSE, ch, obj, victim, TO_CHAR);

		obj_from_char(obj);
		obj_to_char(obj, ch);
		save_char(ch);
		save_char(victim);
	}
}
