#ifndef __INFO_H__
#define __INFO_H__

#include "conf.h"
#include "sysdep.h"

#include "structs.h"
#include "utils.h"

#include "interpreter.h"


/* For show_obj_to_char 'mode'.	/-- arbitrary */
#define SHOW_OBJ_LONG		0
#define SHOW_OBJ_SHORT		1
#define SHOW_OBJ_ACTION		2


/* act.informative.c */
extern void look_at_target(struct char_data *ch, char *arg);
extern int sort_commands_helper(const void *a, const void *b);
extern void sort_commands(void);

extern ACMD(do_color);
extern ACMD(do_commands);
extern ACMD(do_gen_ps);
extern ACMD(do_help);
extern ACMD(do_look);
extern ACMD(do_time);
extern ACMD(do_toggle);
extern ACMD(do_weather);


/* act.info.char.c */
extern void diag_char_to_char(struct char_data *i, struct char_data *ch);
extern void look_at_char(struct char_data *i, struct char_data *ch);
extern void list_one_char(struct char_data *i, struct char_data *ch);
extern void list_char_to_char(struct char_data *list, struct char_data *ch);
extern void perform_mortal_where(struct char_data *ch, char *arg);
extern void perform_immort_where(struct char_data *ch, char *arg);

extern ACMD(do_consider);
extern ACMD(do_diagnose);
extern ACMD(do_levels);
extern ACMD(do_score);
extern ACMD(do_users);
extern ACMD(do_who);
extern ACMD(do_where);
extern ACMD(do_whois);


/* act.info.obj.c */
extern void show_obj_to_char(struct obj_data *obj, struct char_data *ch, 
					int mode);
extern void show_obj_modifiers(struct obj_data *obj, struct char_data *ch);
extern void list_obj_to_char(struct obj_data *list, struct char_data *ch, 
					int mode, int show);
extern void look_in_obj(struct char_data *ch, char *arg);
extern char *find_exdesc(char *word, struct extra_descr_data *list);
extern void print_object_location(int num, struct obj_data *obj, 
					struct char_data *ch, int recur);

extern ACMD(do_equipment);
extern ACMD(do_examine);
extern ACMD(do_gold);
extern ACMD(do_inventory);


/* act.info.room.c */
extern void do_auto_exits(struct char_data *ch);
extern void look_at_room(struct char_data *ch, int ignore_brief);
extern void look_in_direction(struct char_data *ch, int dir);

extern ACMD(do_exits);

#endif /* __INFO_H__ */
